#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void	convpic(int,int,int c_pixel[8][8],int pixel[16][8]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[16][8];
	int		c_pixel[8][8];

	int		width_all,height_all;
	int		width,height;
	int		za;
	int		x,y,col;
	int		c,i,sft,a0,a1;
	int		patcnt;

	if (argc != 4) {
		fprintf(stderr, "Usage: convchara infile outfile patcnt\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	patcnt = atoi(argv[3]);

	width  = 16;
	height = 8;

	for (za = 0;za < patcnt;za ++) {

				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel[x][y] = 0x08;
					}
				}

/* GRB */
				for (col = 0x01;col < 0x08;col *= 2) {
					for (y = 0;y < height;y ++) {
						for (x = 0;x < width;x += 8) {
							c = fgetc(infp);
							sft = 0x80;
							for (i = 0;i < 8;i ++) {
								if ( (c & sft) != 0) {
									pixel[x+i][y] |= col;
								}
								sft /= 2;
							}
						}
					}
				}

/* A */
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {

						if (pixel[x][y] == 0x0b) {
							pixel[x][y] = 0x08;
						} else if (pixel[x][y] == 0x08) {
							pixel[x][y] = 0x0b;
						}

					}
				}

				convpic(16,8,c_pixel,pixel);

				for (y = 0;y < height;y ++) {
					for (x = 0;x < width/2;x += 2) {
						a0 = (c_pixel[x+0][y] & 0x0f) << 4;
						a1 = (c_pixel[x+1][y] & 0x0f);
						fputc(a0|a1, outfp);
					}
				}

	}


	fclose(outfp);

	fclose(infp);

	return(0);
}


void	convpic(int picsize_x,int picsize_y,int c_pixel[8][8],int pixel[16][8])
{

	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	return;
}

